export interface CrateConfig {
    sqlEndpoint?: string;
    auth?: string;
}
export interface QueryResult {
    cols: string[];
    col_types?: number[];
    rows: any[][];
    rowcount: number;
    duration: number;
}
export interface BulkQueryResult {
    cols: string[];
    results: {
        rowcount: number;
    }[];
    duration: number;
}
export interface ErrorResult {
    error: {
        message: string;
        code: number;
    };
}
export interface QueryOptions {
    args?: any[];
    coltypes?: boolean;
}
export declare const crate: (config?: CrateConfig) => {
    query: (sql: string, options?: QueryOptions) => Promise<QueryResult | ErrorResult>;
    insert: (qualifiedName: string, record: object) => Promise<QueryResult | ErrorResult>;
    upsert: (qualifiedName: string, record: object, update: object) => Promise<QueryResult | ErrorResult>;
    bulkInsert: (qualifiedName: string, records: object[]) => Promise<BulkQueryResult | ErrorResult>;
    deleteById: (qualifiedName: string, id: string) => Promise<QueryResult | ErrorResult>;
};
export declare type Crate = ReturnType<typeof crate>;
